function [lamda_p, lamda_q, mu_vl, mu_vu, mu_Pg_low, mu_Pg_upp, mu_Qg_low, mu_Qg_upp, mu_Af, mu_At] 	...
			= compute_sp_lamda (duals, ng, nl, nb, pvpq, ref, gbus, dAf_dVm, dAf_dVa, dAt_dVm, dAt_dVa, dSbus_dVm, dSbus_dVa);	

% compute lamda of load flow eqations, mu of line constraints and voltage constraints, etc.
% The algorithm is based on sparse formulation of opf.

%   MATPOWER Version 1.0
%   by Deqiang (David) Gan, PSERC Cornell    9/17/97
%   Copyright (c) 1997 by Power System Engineering Research Center (PSERC)
%   See http://www.pserc.cornell.edu/ for more info.

nb1 = nb-1;

%% compute lamda

% get mu of functional constraints
mu_Af = 	duals(ng+2*nb+1						:ng+2*nb+nl);
mu_At = 	duals(ng+2*nb+nl+1					:ng+2*nb+2*nl);
mu_vu = 	duals(ng+2*nb+2*nl+1				:ng+2*nb+2*nl+nb);
mu_vl = 	duals(ng+2*nb+2*nl+nb+1				:ng+2*nb+2*nl+2*nb);

mu_Pg_upp = duals(ng+2*nb+2*nl+2*nb+1			:ng+2*nb+2*nl+2*nb+ng);
mu_Pg_low = duals(ng+2*nb+2*nl+2*nb+ng+1		:ng+2*nb+2*nl+2*nb+2*ng);
mu_Qg_upp = duals(ng+2*nb+2*nl+2*nb+2*ng+1		:ng+2*nb+2*nl+2*nb+2*ng+ng);	
mu_Qg_low = duals(ng+2*nb+2*nl+2*nb+2*ng+ng+1	:ng+2*nb+2*nl+2*nb+2*ng+2*ng);

lamda_p = duals(ng+1	:ng+nb);
lamda_q = duals(ng+nb+1	:ng+nb+nb);



return;

